'FFSubmenu=Effekte
'FFName=Kachelschatten

' ********************************************************************
' Kachelschatten.vbs (Script fr FixFoto)
' (c) Harald Maeckler, Dsseldorf 2009
' nach einer Skriptvorlage von JKS am 16.04.2009
' unter http://www.ffsf.de/showpost.php?p=155828&postcount=36

' Funktion:	Aktives Bild kacheln und Kachelschatten und/oder Transparenz erzeugen
'			Kachelanzahl in der Horizontalen und ab Version 3.00 auch in der Vertikalen,
'			Fugenbreite und Fugenfarbe sind eingebbar
'
' Version 3.08 vom 26.01.2014	- Update-Funktion hinzu
' Version 3.07 vom 23.07.2010	- auch schattenfreie Fugen mit Versatz mglich
' Version 3.06 vom 23.07.2010	- Erzeugung schattenfreier Fugen optimiert
' Version 3.05 vom 27.06.2010	- Fehler bei 'gezielter Transparenzauswahl' beseitigt
' Version 3.04 vom 26.06.2010	- Bildverlust rechts und unten um eine Fugenbreite
'								  bei Fugen mit Schattenbildung ohne Versatz beseitigt
' Version 3.03 vom 23.06.2010	- bei nur einer Kachel immer mit Versatz
'								- Randstrke in px vorgebbar
' Version 3.02 vom 11.06.2010	- Design der Bedienoberflche gendert
'								- Fortschrittsanzeige in die Bedienoberflche verlagert
'								- Kurzbeschreibung berarbeitet
' Version 3.01 vom 10.06.2010	- quadratisch wenn Kachelanzahl in der Vertikalen
'								  oder horizontalen mit 0 angegeben wird
' Version 3.00 vom 29.05.2010	- Kachelanzahl in der Vertikalen vorgebbar
' Version 2.13 vom 14.09.2009	- Transparenzerzeugung angepasst
' Version 2.12 vom 13.09.2009	- bei 'Fugen mit Schattenbildung' Option 'ohne Versatz' hinzu
' Version 2.11 vom 01.07.2009	- Speicherortermittlung fr FixFotoScript.ini gendert
' Version 2.10 vom 30.06.2009	- Bereinigung der FixFotoScript.ini vereinfacht
' Version 2.09 vom 29.06.2009	- Lschroutine hinzugefgt und KB entsprechend ergnzt
' Version 2.08 vom 28.06.2009	- nach Beendigung des Skripts wird temp.bmp gelscht
' Version 2.07 vom 19.06.2009	- Bug in der Registryauswertung beseitigt
' Version 2.06 vom 18.06.2009	- Bei Direktauswahl der Transparenz kann fr jede Kachel die
'								  Transparenzstufe zwischen 0 und 8 eingestellt werden
' Version 2.05 vom 11.06.2009	- Maximaler Transparenzwert einstellbar und KB angepasst
' Version 2.04 vom 09.06.2009	- berarbeitung der Kurzbeschreibung
' Version 2.03 vom 08.06.2009	- Startverschiebungsmglichkeit bei 'abwechselnder Transparenz' 
' Version 2.02 vom 07.06.2009	- Transparenz whlbar mit gezielter Auswahl
' Version 2.01 vom 04.06.2009	- Transparenz whlbar
'									- mit wechselnder Auswahl
'									- mit zuflliger Auswahl
'									- mit zuflligen Werten
' Version 2.00 vom 03.06.2009	- berarbeitung der Kurzbeschreibung
' Version 1.09 vom 02.06.2009	- bei deaktivierter Schattenbildung Gitter (flache Fugen) erzeugen
' Version 1.08 vom 29.05.2009	- Schatten und/oder wechselnde Transparenz whlbar
' Version 1.07 vom 21.04.2009	- Auswahl Crop/Scale wieder entfernt - Scale als Standard eingebaut
'								- Skript aufgerumt
' Version 1.06 vom 20.04.2009	- FF_Scale ersetzt durch FF_HQScale wegen Fehler in FF_Scale
' Version 1.05 vom 19.04.2009	- Farbwahl fr die Fugen hinzugefgt
'								- Test Crop und Scale zur Vermeidung weier Striche
' Version 1.04 vom 19.04.2009	- weitere Bugs beseitigt und Notbremse wieder raus
' Version 1.03 vom 18.04.2009	- Notbremse im Sub Originalmix
' Version 1.02 vom 18.04.2009	- Bug beseitigt
' Version 1.01 vom 18.04.2009	- Evtl. auftretende Rundungsfehler beseitigt
' Version 1.00 vom 18.04.2009	- Betaversion

'** Start Kurzbeschreibung *******************************************
' Kachelschatten / Version 3.07
' ==================
' Das Skript dient zur Kachelung des aktiven Bildes mit oder ohne Schattenbildung bei den Fugen
' und ohne oder mit Transparenz der Kacheln auf verschiedene, whlbare Art und Weise.
'
' Grundeinstellungen
' -----------------------
' Die gewnschte Anzahl der Kacheln in der Horizontalen und Vertikalen muss eingegeben werden.
' Die Kachelbreite ergibt sich automatisch aus der Bildbreite dividiert durch die Anzahl.
'
' Ist die horizontale oder vertikale Kachelanzahl = 0, wird die Kachelhhe so berechnet, dass
' die Kacheln annhernd quadratisch erscheinen und gleichzeitig die Anzahl der Kacheln in der
' Vertikalen bzw. Horizontalen eine ganze Zahl ergeben.
'
' Ist die Kachelanzahl fr die Horizontale und die Vertikale <= 1, wird nur eine Kachel erzeugt.
'
' Die Fugenbreite wird in Pixeln eingegeben. Die Gre sollte in einem vernnftigen Verhltnis 
' zur Bildauflsung stehen (ausprobieren!).
'
' Die Fugenfarbe dazu ist frei whlbar
'
' Ist 'Fugen mit Schattenbildung' aktiviert, wird in den Fugen ein Schatten  mit Lichtquelle von
' links oben erzeugt. Das mit Schattenfugen gekachelte Bild ist standardmig in Hhe und Breite
' um die Kachelzahl multipliziert mit der Fugenbreite grer, weil alle Bildteile als Kacheln
' jeweils versetzt um die Fugenbreite eingefgt werden. Wird die Option 'ohne Versatz'
' gewhlt, wird das Bild nur um eine Fugenbreite hher und breiter, weil die Bildteile jeweils in
' Hhe und Breite um die Fugenbreite beschnitten werden.
' Ist 'Fugen ohne Schattenbildung' aktiviert, werden flache Fugen in Fugenfarbe erzeugt. Dabei 
' bleibt bei der Wahl 'ohne Versatz' Hhe und Breite des Bildes erhalten, bei 'mit Versatz'
' wird das Bild in Hhe und Breite um die Kachelzahl -1 multipliziert mit der Fugenbreite grer.
'
' 'Rand in Fugenfarbe' bewirkt, dass das gekachelte Bild in der gewhlten Fugenfarbe um eine defi-
' nierte Randbreite erweitert wird. Bei 'Fugen mit Schattenbildung' betrifft das nur den linken und
' oberen Rand, da rechts und unten wegen der Schattenbildung bereits ein Rand vorhanden ist.
'
' Transparenz
' ---------------
' Die Kacheln knnen auf Wunsch mit Transparenz versehen werden. Der maximale Transparenzwert
' kann zwischen 0 (keine Transparenz) und 8 (maximal mglicher Transparenzwert) eingestellt
' werden. Eine Feinjustage ist ber die Cursortasten mglich.
'
' Erluterung zu den Transparenzwerten:
' Aus den einstellbaren Stufen 0 bis 8 werden die verarbeitbaren Transparenzwerte zwischen 0 und
' 255 mit der Formel Stufe * 32 - 1 berechnet, wobei Stufe 0 immer Transparenz = 0 ergibt.
'
'
' Als Transparenzoptionen knnen gewhlt werden:
'
' - wechselnder Auswahl
' Dabei erhlt jede zweite Kachel den maximalen Transparenzwert. Angefangen wird mit der ersten
' Kachel oben links. Mit gesetztem Verschiebungsflag wird mit der zweiten Kachel oben links 
' begonnen.
'
' - zuflliger Auswahl
' Zufllig ausgewhlte Kacheln erhalten den maximalen Transparenzwert.
'
' - zuflligen Werten
' Es werden alle Kacheln mit zuflligen Transparenzwerten zwischen 0 und dem maximalen Trans-
' parenzwert versehen.
'
' - direkter Auswahl
' Nach Bettigung von 'Auswahl' wird eine Matrix entsprechend den geplanten Kacheln generiert
' und angezeigt. Aus programmtechnischen Grnden darf die Matrix aber nur max. 200 Elemente
' enthalten. Beispielsweise ergibt bei einem Seitenverhltnis des Bildes von 3 : 2 die gewhlte
' Kachelanzahl von 18 in der Horizontalen eine Kachelanzahl von 12. Zur Darstellung sind also 
' 18 x 12 Elemente = 216 erforderlich und damit zu viel. Es erfolgt eine Meldung.
'
' Bei jedem Element kann die Transparenzstufe zwischen 0 und 8 rechts neben dem Anzeigefeld
' durch Mausklick auf die Pfeile 'nach oben' (+1) bzw. 'nach unten' (-1) eingestellt werden.
' Mit 'bernehmen' wird der Matrixzustand abgespeichert und die Wahl der 'Kachelanzahl in der
' Horizontalen' gesperrt, da die Matrix nur fr die vorher definierte Kachelanzahl gltig ist.
' Die Sperre kann mit 'Lschen' oder Wahl einer anderen Transparenzoption aufgehoben werden.
'
' Hinweis:
' Wird das Skript bei einem aktiven Bild mit einem anderen Seitenverhltnis gestartet und es 
' besteht noch eine Auswahl, wird diese mglicherweise verschoben sein, da sich durch das gen-
' derte Seitenverhltnis die Anzahl der vertikalen Kacheln ndert.
'
' Tipp:
' Wer bei der 'direkten Auswahl' auf die individuelle Einstellbarkeit der Transparenzwerte fr 
' jede einzelne Kachel verzichten will, kann im Skript die Konstante DW_mE (Direktwahl mit Ein-
' stellmglichkeit) auf false stellen. Dann knnen in der Matrix die Kacheln einzeln aktiviert
' und dadurch fr diese Kachel der eingestellte Maximalwert der Transparenz bernommen werden.
'
' Deinstallation
' ========
' Wird die Entfernung des Skripts gewnscht, kann mit der Tastenkombination Alt + D eine Lsch-
' routine aufgerufen werden. Nach einer Sicherheitsabfrage wird berprft, ob das zugehrige
' zip-Archiv im Skriptordner abgelegt ist. Wenn ja, wird vor dem Lschen angeboten, davon eine
' Sicherheitskopie an einem beliebigen Speicherort abzulegen. Danach werden nacheinander die
' Skriptdatei, die in der Registry dazugehrenden Daten und eventuelle Zusatzdateien gelscht.
' Abschlieend wird die FixFotoScript.ini bereinigt.
' Nach manueller Durchfhrung einer 'Automatischen Skriptkonfiguration' ist das Skript mit allen
' Komponenten aus der FixFoto-Umgebung entfernt.
'
'
' Benutzung des Skripts auf eigene Gefahr!
'
' Copyright Harald Maeckler, Dsseldorf 2010
'** Ende Kurzbeschreibung ********************************************

Option Explicit

'Updatekonstanten und Variable
const SkriptVersion = "3.08"
const SkriptURL = "http://www.ffsf.de/local_links.php?catid=235&linkid=831"
Dim UrlVersion,UrlV_Zahl,SkriptV_Zahl,SkriptEnde

const DW_mE = true											'true  = Direktwahl mit Einstellmglichkeit
															'false = Direktwahl ohne Einstellmglichkeit
Dim Breite,OrgBreite,Hoehe,OrgHoehe,Antwort
Dim AnzahlH,AnzahlV,Kachelbreite,Kachelhoehe,LinSt,boolSchatten,flagOVers,mitRand,RandSt
Dim AnzV,AnzH
Dim boolTransparenz,MaxTransWert
Dim flagAbwechslung,flagTStart,flagZufall,flagZufallswerte,flagGezielt
Dim LinCol,RGB,Farbe
Dim TempFile,KachelSh_H,KachelSh_V
Dim GesamtKZ,KZ,K_Auswahl,KW(200),KWr,TransWerte
Dim AuswahlWahl : AuswahlWahl = false

const SkriptName = "KachelSchatten.vbs"						'Skriptname
Dim Kurzbeschreibung, KBvorhanden, LaengeMax, Abbruch		'Kurzbeschreibung
const ForReading = 1, ForWriting = 2, ForAppending = 8

Dim objFS													'Objekte
Set objFS = CreateObject("Scripting.FileSystemObject")
Dim WshShell
Set WshShell = CreateObject("WScript.Shell")

Dim SkriptKill
SkriptKill = false	'bei true wird mit Beenden des Skripts dieses komplett mit Registrydaten gelscht !!!
'---------------------------------------------------------------------
call Main
'---------------------------------------------------------------------
Sub Main

on error resume next									'Kontrolle ob Skript in FF-Umgebung gestartet wurde
	Breite = FF_GetImageWidth()	'Breite
 	if Err.Number = 500 then
		msgbox "Das Skript funktioniert nur in der Programmumgebung von FixFoto!",vbCritical,"Abbruch"
		exit sub
	end if
on error goto 0

if Breite = 0 then										'Kontrolle ob ein Bild geladen ist
	msgbox "Kein Bild geladen!",vbCritical,"Abbruch"
	exit sub
end if

OrgBreite = Breite
Hoehe = FF_GetImageHeight()
OrgHoehe = Hoehe

'** Start Dialog Kachelschatten **
FF_AddDialog "Kachelschatten",235,136
FF_AddControl "Kachelschatten","Grundeinstellungen","GROUP",5,6,108,100
FF_AddControl "Kachelschatten","Kachelanzahl in der Horizontalen","STATIC",9,18,80,10
FF_AddControl "Kachelschatten","AnzahlH","SLEDIT",90,18,18,10
FF_SetControlStyle "Kachelschatten","AnzahlH",8193
FF_AddControl "Kachelschatten","Kachelanzahl in der Vertikalen","STATIC",9,29,80,10
FF_AddControl "Kachelschatten","AnzV","SLEDIT",90,29,18,10
FF_SetControlStyle "Kachelschatten","AnzV",8193
FF_AddControl "Kachelschatten","Fugenbreite [px]","STATIC",9,41,80,10
FF_AddControl "Kachelschatten","LinSt","SLEDIT",90,41,18,10
FF_SetControlStyle "Kachelschatten","LinSt",8193
FF_AddControl "Kachelschatten","Fugenfarbe","STATIC",9,52,76,10
FF_AddControl "Kachelschatten","LinCol","COLOR",89,52,20,10
FF_AddControl "Kachelschatten","Fugen:","STATIC",9,64,68,10
FF_AddControl "Kachelschatten","boolSchatten","BOOL",10,75,8,8
FF_SetControlStyle "Kachelschatten","boolSchatten",16384
FF_AddControl "Kachelschatten","mit Schatten","STATIC",22,74,32,10
FF_AddControl "Kachelschatten","boolOhneSchatten","BOOL",62,75,8,8
FF_SetControlStyle "Kachelschatten","boolOhneSchatten",16384
FF_AddControl "Kachelschatten","ohne Schatten","STATIC",74,74,36,10
FF_AddControl "Kachelschatten","flagMVers","BOOL",10,85,8,8
FF_SetControlStyle "Kachelschatten","flagMVers",16384
FF_AddControl "Kachelschatten","mit Versatz","STATIC",22,84,33,10
FF_AddControl "Kachelschatten","flagOVers","BOOL",62,85,8,8
FF_SetControlStyle "Kachelschatten","flagOVers",16384
FF_AddControl "Kachelschatten","ohne Versatz","STATIC",74,84,33,10
FF_AddControl "Kachelschatten","mitRand","BOOL",10,95,8,8
FF_AddControl "Kachelschatten","Rand in Fugenfarbe [px]","STATIC",20,94,86,10
FF_AddControl "Kachelschatten","RandSt","SLEDIT",90,94,18,10
FF_SetControlStyle "Kachelschatten","RandSt",8193
FF_AddControl "Kachelschatten","Transparenz","GROUP",120,6,110,100
FF_AddControl "Kachelschatten","boolTransparenz","BOOL",212,5,8,8
FF_SetControlStyle "Kachelschatten","boolTransparenz",16384
FF_AddControl "Kachelschatten","flagAbwechslung","BOOL",126,18,8,8
FF_SetControlStyle "Kachelschatten","flagAbwechslung",16384
FF_AddControl "Kachelschatten","mit abwechs. Auswahl","STATIC",138,16,56,10
FF_AddControl "Kachelschatten","flagTStart","BOOL",199,18,8,8
FF_AddControl "Kachelschatten","flagZufall","BOOL",126,28,8,8
FF_SetControlStyle "Kachelschatten","flagZufall",16384
FF_AddControl "Kachelschatten","mit zuflliger Auswahl","STATIC",137,27,84,10
FF_AddControl "Kachelschatten","flagZufallswerte","BOOL",126,38,8,9
FF_SetControlStyle "Kachelschatten","flagZufallswerte",16384
FF_AddControl "Kachelschatten","mit zuflligen Werten","STATIC",137,37,87,10
FF_AddControl "Kachelschatten","flagGezielt","BOOL",126,48,8,9
FF_SetControlStyle "Kachelschatten","flagGezielt",16384
FF_AddControl "Kachelschatten","mit gezielter","STATIC",137,47,31,10
FF_AddControl "Kachelschatten","Auswahl","BUTTON",171,47,25,10
FF_AddControl "Kachelschatten","/","STATIC",198,47,4,10
FF_AddControl "Kachelschatten","Versch.","STATIC",209,17,19,10
FF_AddControl "Kachelschatten","Lschen","BUTTON",202,47,25,10
FF_AddControl "Kachelschatten","Maximaler Transparenzwert","STATIC",126,64,96,10
FF_SetControlStyle "Kachelschatten","Maximaler Transparenzwert",1
FF_AddControl "Kachelschatten","MaxTransEinstellung","HSLIDER",126,75,98,18
FF_AddControl "Kachelschatten","0     1     2     3     4     5     6     7     8","STATIC",132,92,90,11
FF_AddControl "Kachelschatten","Fortschritt","PROGRESS",5,110,224,5
FF_AddControl "Kachelschatten","?","BUTTON",21,120,11,11
FF_AddControl "Kachelschatten","Start","BUTTON",185,120,33,11
FF_AddControl "Kachelschatten","&d","BUTTON",42,171,1,1
FF_AddControl "Kachelschatten","|","STATIC",35,120,22,11
FF_SetControlStyle "Kachelschatten","|",1
FF_AddControl "Kachelschatten","Update","BUTTON",60,120,33,11
'** End Dialog Kachelschatten **

call RegistryLesen
FF_ActivateControl "Kachelschatten","&d"
FF_SetDialogTimer "Kachelschatten", 100

do
	Select Case FF_ShowDialog ("Kachelschatten")
	
	Case "&d"	'Skript Delete-Aufruf
		Antwort = msgbox("Soll das Skript " & SkriptName & vbNewline & _
						 " mit allen dazugehrigen Komponenten wirklich gelscht werden?",vbYesNo + vbQuestion,"Sicherheitsabfrage")
		if Antwort = vbYes then
			SkriptKill = true
			exit do
		end if
	Case "TIMER"
		FF_SetControl "Kachelschatten" ,"|","V " & Skriptversion
		FF_SetDialogTimer "Kachelschatten", 0
	Case "boolSchatten"
			FF_SetControl "Kachelschatten","boolSchatten",1
			FF_SetControl "Kachelschatten","boolOhneSchatten",0
	Case "boolOhneSchatten"
			FF_SetControl "Kachelschatten","boolSchatten",0
			FF_SetControl "Kachelschatten","boolOhneSchatten",1
	Case "flagOVers"
			FF_SetControl "Kachelschatten","flagOVers",1
			FF_SetControl "Kachelschatten","flagMVers",0
	Case "flagMVers"
			FF_SetControl "Kachelschatten","flagOVers",0
			FF_SetControl "Kachelschatten","flagMVers",1
	Case "boolTransparenz"
		if FF_GetControl ("Kachelschatten","boolTransparenz") = 0 then
			K_Auswahl = ""
			FF_EnableControl "Kachelschatten","AnzahlH",true
			FF_EnableControl "Kachelschatten","AnzV",true
		end if
	Case "flagAbwechslung"
		FF_SetControl "Kachelschatten","flagAbwechslung",1
		FF_SetControl "Kachelschatten","flagZufall",0
		FF_SetControl "Kachelschatten","flagZufallswerte",0
		FF_SetControl "Kachelschatten","flagGezielt",0
		K_Auswahl = ""
		FF_EnableControl "Kachelschatten","AnzahlH",true
		FF_EnableControl "Kachelschatten","AnzV",true
	Case "flagZufall"
		FF_SetControl "Kachelschatten","flagAbwechslung",0
		FF_SetControl "Kachelschatten","flagZufall",1
		FF_SetControl "Kachelschatten","flagZufallswerte",0
		FF_SetControl "Kachelschatten","flagGezielt",0
		K_Auswahl = ""
		FF_EnableControl "Kachelschatten","AnzahlH",true
		FF_EnableControl "Kachelschatten","AnzV",true
	Case "flagZufallswerte"
		FF_SetControl "Kachelschatten","flagAbwechslung",0
		FF_SetControl "Kachelschatten","flagZufall",0
		FF_SetControl "Kachelschatten","flagZufallswerte",1
		FF_SetControl "Kachelschatten","flagGezielt",0
		K_Auswahl = ""
		FF_EnableControl "Kachelschatten","AnzahlH",true
		FF_EnableControl "Kachelschatten","AnzV",true
	Case "flagGezielt"
		FF_SetControl "Kachelschatten","flagAbwechslung",0
		FF_SetControl "Kachelschatten","flagZufall",0
		FF_SetControl "Kachelschatten","flagZufallswerte",0
		FF_SetControl "Kachelschatten","flagGezielt",1
	Case "Auswahl"
		AuswahlWahl = true
		call WerteAuslesen
		AuswahlWahl = false
		if flagGezielt = 1 then
			if (AnzahlH * AnzahlV) > 200 then
				msgbox "Zur 'gezielten Transparenzauswahl' ist die Kachelanzahl zu hoch!" & vbNewline & _
			   "Es drfen max. 200 sein (Anzahl horizontal x Anzahl vertikal).",vbInformation,"Hinweis"
			else
				if DW_mE then
					call GezielteAuswahl_mE
				else
					call GezielteAuswahl_oE
				end if
			end if
		end if
	Case "Lschen"
		K_Auswahl = ""
		FF_EnableControl "Kachelschatten","AnzahlH",true
		FF_EnableControl "Kachelschatten","AnzV",true
	Case "?"
		'FF_SetControl "Kachelschatten","Fortschritt",65	'############## nur fr Screenshot
		Abbruch = false
		if not KBvorhanden then	call KurzbeschreibungLesen
		if KBvorhanden then
			call KurzbeschreibungAnzeigen
		else
			msgbox "Keine Kurzbeschreibung gefunden!",vbExclamation,"Meldung"
		end if
	Case "Update"
		SkriptEnde = false
		call Update
		if SkriptEnde then exit do
	Case "Start"
		call WerteAuslesen
		call Kontrolle

		if not Abbruch then
		
			if boolSchatten = 1 then
				if flagOVers then
					call Schattenbildung_oV
					call OriginalMix_oV
				else
					call Schattenbildung_mV
					call OriginalMix_mV			
				end if
			else
				if flagOVers then
					call Umrandung_oV
				else
					call Umrandung_mV
				end if
			end if
			
			if boolTransparenz = 1 then	call TransparenzErzeugung
			
			if boolSchatten = 1 then
				if mitRand = 1 then FF_ExtendCanvas RandSt,0,RandSt,0,Farbe(0),Farbe(1),Farbe(2)
			else
				if mitRand = 1 then FF_ExtendCanvas RandSt,RandSt,RandSt,RandSt,Farbe(0),Farbe(1),Farbe(2)
			end if
			
			FF_Reload
			exit do
		end if
	Case "CANCEL"
		exit do
	Case Else
	End Select
loop

call RegistrySchreiben
FF_CloseDialog ("Kachelschatten")

if objFS.FileExists(TempFile) then	'TempFile lschen
	objFS.DeleteFile TempFile,true
end if

if SkriptKill then call KillSkript	'ggf. Skript komplett entfernen

End sub
'---------------------------------------------------------------------
Sub Kontrolle
Abbruch = false

if boolSchatten = 0 and boolTransparenz = 0 and LinSt = 0 then
	msgbox "Es fehlen Einstellwerte!",vbInformation,"Hinweis"
	Abbruch = true
	exit sub
end if

if boolSchatten = 1 and LinSt < 3 then
	msgbox "Die Fugenbreite muss mindestens 3 Pixel betragen!",vbInformation,"Hinweis"
	Abbruch = true
	exit sub
end if

if boolTransparenz = 1 and flagGezielt = 1 then
	if K_Auswahl = "" then
		msgbox "Fr die 'gezielte Auswahl' sind keine Kacheln ausgewhlt!",vbInformation,"Hinweis"
		Abbruch = true
		exit sub
	end if
end if

End sub
'---------------------------------------------------------------------
Sub WerteAuslesen
'Werte auslesen, Vorberechnungen und Bildsicherung als TempFile

AnzahlH = FF_GetControl("Kachelschatten","AnzahlH")
if AnzahlH = "" then AnzahlH = 0
AnzV = FF_GetControl("Kachelschatten","AnzV")
if AnzV = "" then AnzV = 0
LinSt = FF_GetControl("Kachelschatten","LinSt")
if LinSt = "" then LinSt = 0
RandSt = FF_GetControl("Kachelschatten","RandSt")
if RandSt = "" then RandSt = 0
LinCol = FF_GetControl("Kachelschatten","LinCol")
Farbe = split(LinCol," ")
RGB = Farbe(0) + Farbe(1) * (2^8) + Farbe(2) * (2^16)
boolSchatten = FF_GetControl("Kachelschatten","boolSchatten")
flagOVers = FF_GetControl("Kachelschatten","flagOVers")
mitRand = FF_GetControl("Kachelschatten","mitRand")
boolTransparenz = FF_GetControl("Kachelschatten","boolTransparenz")
flagAbwechslung = FF_GetControl("Kachelschatten","flagAbwechslung")
flagTStart = FF_GetControl("Kachelschatten","flagTStart")
flagZufall = FF_GetControl("Kachelschatten","flagZufall")
flagZufallswerte = FF_GetControl("Kachelschatten","flagZufallswerte")
flagGezielt = FF_GetControl("Kachelschatten","flagGezielt")
MaxTransWert = FF_GetControl("Kachelschatten","MaxTransEinstellung")

if boolSchatten = 1 and flagOVers = 1 and not AuswahlWahl then
	FF_ExtendCanvas 0,LinSt,0,LinSt,Farbe(0),Farbe(1),Farbe(2)
	Breite = FF_GetImageWidth()
	Hoehe = FF_GetImageHeight()
end if


if AnzahlH < 2 and AnzV < 2 then
	AnzahlH = 1 : AnzahlV = 1
	Kachelbreite = Breite
	Kachelhoehe = Hoehe
elseif AnzV = 0 then
	Kachelbreite = round(Breite / AnzahlH)	'ganzzahlige Kachelbreite
	Breite = AnzahlH * Kachelbreite			'neue Breite mit ganzzahliger Kachelbreite
	Kachelbreite = Breite / AnzahlH	
	AnzahlV = round(Hoehe / Kachelbreite)	'AnzahlV abgeschtzt
	Kachelhoehe = round(Hoehe / AnzahlV)	'ganzzahlige Kachelhhe
	Hoehe = Kachelhoehe * AnzahlV			'neue Hhe mit ganzzahliger Kachelhhe
elseif AnzahlH = 0 then
	Kachelhoehe = round(Hoehe / AnzV)		'ganzzahlige Kachelhhe
	Hoehe = AnzV * Kachelhoehe				'neue Hhe mit ganzzahliger Kachelhhe
	Kachelhoehe = Hoehe / AnzV
	AnzahlV = AnzV
	AnzahlH = round(Breite / Kachelhoehe)	'AnzH abgeschtzt
	Kachelbreite = round(Breite / AnzahlH)	'ganzzahlige Kachelbreite
	Breite = Kachelbreite * AnzahlH			'neue Breite mit ganzzahliger Kachelbreite
else
	Kachelbreite = round(Breite / AnzahlH)	'ganzzahlige Kachelbreite
	Breite = AnzahlH * Kachelbreite			'neue Breite mit ganzzahliger Kachelbreite
	Kachelbreite = Breite / AnzahlH
	AnzahlV = AnzV
	Kachelhoehe = round(Hoehe / AnzV)		'ganzzahlige Kachelhhe
	Hoehe = AnzV * Kachelhoehe				'neue Hhe mit ganzzahliger Kachelhhe
	Kachelhoehe = Hoehe / AnzV
end if

FF_HQScale Breite, Hoehe, false			'skalieren auf neue Breite und Hhe

KachelSh_H = Breite + AnzahlH * LinSt
KachelSh_V = Hoehe + AnzahlV * LinSt

'Bildung der Gesamtanzahl Schritte zur Kachelerzeugung
GesamtKZ = AnzahlH * AnzahlV
if boolSchatten = 1 then
	if boolTransparenz = 0 then 
		GesamtKZ = GesamtKZ * 2
	else
		GesamtKZ = GesamtKZ * 3
	end if
end if
if boolSchatten = 0 then
	if boolTransparenz = 0 then 
		GesamtKZ = AnzahlH + AnzahlV
	else
		GesamtKZ = GesamtKZ + AnzahlH + AnzahlV
	end if
end if

'temporr speichern
TempFile = FF_GetScriptPath & "\temp.bmp"
FF_SaveImage TempFile,0

End sub
'---------------------------------------------------------------------
Sub Schattenbildung_mV
'neues Bild mit Kachelschatten mit Versatz

Dim y,yo,x,xo,i,xs,ys,Transparenz

FF_NewImage KachelSh_H,KachelSh_V,RGB
for y = 0 to Hoehe step Kachelhoehe					'Vertikale
	if y = 0 then yo = 0 else yo = yo + LinSt
	
	for x = 0 to Breite step Kachelbreite			'Horizontale
		if x = 0 then xo = 0 else xo = xo + LinSt
		
		KZ = KZ + 1									'Fortschrittsanzeige
		FF_SetControl "Kachelschatten","Fortschritt",KZ/GesamtKZ*100

		for i = LinSt - 1 to i = 1 step - 1
			Transparenz = (LinSt-i) * 255 / (LinSt-1)
			xs = x + i + xo
			ys = y + i + yo
			FF_AreaFillRect xs,ys,xs+Kachelbreite,ys+Kachelhoehe,Transparenz
		next
	next
next

FF_AdjustRGB 0,0,0
FF_PushImage

End sub
'---------------------------------------------------------------------
Sub Schattenbildung_oV
'neues Bild mit Kachelschatten ohne Versatz

Dim y,yo,x,xo,i,xs,ys,Transparenz

FF_NewImage Breite,Hoehe,RGB
for y = 0 to Hoehe step Kachelhoehe - LinSt					'Vertikale
	if y = 0 then yo = 0 else yo = yo + LinSt
	
	for x = 0 to Breite step Kachelbreite - LinSt			'Horizontale
		if x = 0 then xo = 0 else xo = xo + LinSt
		
		KZ = KZ + 1											'Fortschrittsanzeige
		FF_SetControl "Kachelschatten","Fortschritt",KZ/GesamtKZ*100

		for i = LinSt - 1 to i = 1 step - 1
			Transparenz = (LinSt-i) * 255 / (LinSt-1)
			xs = x + i + xo
			ys = y + i + yo
			FF_AreaFillRect xs,ys,xs+Kachelbreite - LinSt,ys+Kachelhoehe - LinSt,Transparenz
		next
	next
next

FF_AdjustRGB 0,0,0
FF_PushImage

End Sub
'------------------------------------------------------------------------
Sub OriginalMix_mV
'Originalbild mixen mit Schattenbild mit Versatz

Dim y,yo,x,xo,xs,ys

for y = 0 to Hoehe - .5 step Kachelhoehe						'Vertikale
	if y = 0 then yo = 0 else yo = yo + LinSt

	for x = 0 to Breite - .5 step Kachelbreite					'Horizontale
		if x = 0 then xo = 0 else xo = xo + LinSt
		
		KZ = KZ + 1												'Fortschrittsanzeige
		FF_SetControl "Kachelschatten","Fortschritt",KZ/GesamtKZ*100
		
		FF_LoadImage TempFile

		FF_Crop x,y,Kachelbreite,Kachelhoehe					'Ausschneiden
			
		xs = x + xo
		ys = y + yo
		FF_MixImage xs,ys,Kachelbreite,Kachelhoehe,255			'Mischen
	next
next

FF_PopImage

'Bildgre rekonstruieren
FF_HQScale OrgBreite+AnzahlH*LinSt,OrgHoehe+AnzahlV*LinSt,false

End sub
'---------------------------------------------------------------------
Sub OriginalMix_oV
'Originalbild mixen mit Schattenbild ohne Versatz

Dim x,y

for y = 0 to Hoehe - .5 step Kachelhoehe '- Linst						'Vertikale
	for x = 0 to Breite - .5 step Kachelbreite '- LinSt					'Horizontale
		
		KZ = KZ + 1														'Fortschrittsanzeige
		FF_SetControl "Kachelschatten","Fortschritt",KZ/GesamtKZ*100
		
		FF_LoadImage TempFile
		FF_Crop x,y,Kachelbreite - LinSt,Kachelhoehe - LinSt			'Ausschneiden
		FF_MixImage x,y,Kachelbreite - LinSt,Kachelhoehe - LinSt,255	'Mischen
	next
next

FF_PopImage

'Bildgre rekonstruieren
FF_HQScale OrgBreite+LinSt,OrgHoehe+LinSt,false

End sub
'---------------------------------------------------------------------
Sub GezielteAuswahl_oE
'ohne Einstellung der Transparenz
Dim m,n,v,z,Name,Bdialog
const dlg = "Gezielte Auswahl"

Bdialog = AnzahlH * 8 + 2
if Bdialog < 106 then
	v = 54 - AnzahlH * 4
	Bdialog = 106
else
	v = 1
end if

FF_AddDialog dlg,Bdialog, AnzahlV * 8 + 26

for m = 1 to AnzahlV
	for n = 1 to AnzahlH
		z = z + 1 : Name = cstr(z)
		FF_AddControl dlg,Name,"BOOL",v + (n-1) * 8,2 + (m-1) *8,8,8	
		if instr(K_Auswahl,"/" & Name & "/") > 0 then FF_SetControl dlg,Name,1
	next
next

FF_AddControl dlg,"Abbrechen","BUTTON",Bdialog/2 - 52,m * 8,34,11
FF_AddControl dlg,"Lschen","BUTTON",Bdialog/2 - 17,m * 8,34,11
FF_AddControl dlg,"bernehmen","BUTTON",Bdialog/2 + 18,m * 8,34,11

do	
	Select Case FF_ShowDialog (dlg)
	Case "Lschen"
		z = 0
		for m = 1 to AnzahlV
			for n = 1 to AnzahlH
				z = z + 1 : Name = cstr(z)		
				if instr(K_Auswahl,"/" & Name & "/") > 0 then FF_SetControl dlg,Name,0
			next
		next
		K_Auswahl = ""
		FF_EnableControl "Kachelschatten","AnzahlH",true
		FF_EnableControl "Kachelschatten","AnzV",true
	Case "bernehmen"
		K_Auswahl = "/" : z = 0
		for m = 1 to AnzahlV
			for n = 1 to AnzahlH
				z = z + 1 : Name = cstr(z)
				if FF_GetControl (dlg,Name) = 1 then
					K_Auswahl = K_Auswahl & Name & "/"
				end if
			next
		next
		
		if len(K_Auswahl) > 2 then
			FF_EnableControl "Kachelschatten","AnzahlH",false
			FF_EnableControl "Kachelschatten","AnzV",false
			exit do
		else
			K_Auswahl = ""
			msgbox "Es wurde keine Auswahl getroffen!",vbInformation,"Ergebnis"
		end if
	Case "Abbrechen","CANCEL"
		exit do
	Case Else
	End Select
loop

FF_CloseDialog (dlg)

End Sub
'---------------------------------------------------------------------
Sub GezielteAuswahl_mE
'mit Einstellung der Transparenz
Dim m,n,v1,v2,z,Name,Bdialog,Taste,c
const dlg = "Gezielte Auswahl"

Bdialog = AnzahlH * 20
if Bdialog < 106 then
	v1 = 54 - AnzahlH * 10
	v2 = v1 + 9
	Bdialog = 106
else
	v1 = 2
	v2 = 11
end if

FF_AddDialog dlg,Bdialog, AnzahlV * 18 + 15
for m = 1 to AnzahlV
	for n = 1 to AnzahlH
		z = z + 1
		FF_AddControl dlg,cstr(z),"SLEDIT",v1 + (n-1) * 20,2 + (m-1) * 16,8,10
		FF_SetControlStyle dlg,cstr(z),2049
		if instr(K_Auswahl,"/" & cstr(z) & "/") > 0 then
			if KW(z) = "" then KW(z) = 0
		else
			KW(z) = 0
		end if
		FF_SetControl dlg,cstr(z),KW(z)
		FF_AddControl dlg,"n" & cstr(z),"VSPIN",v2 + (n-1) * 20,1 + (m-1) * 16,10,12
	next
next

FF_AddControl dlg,"Abbrechen","BUTTON",Bdialog/2 - 52,m * 16 - 10,34,11
FF_AddControl dlg,"Lschen","BUTTON",Bdialog/2 - 17,m * 16 - 10,34,11
FF_AddControl dlg,"bernehmen","BUTTON",Bdialog/2 + 18,m * 16 - 10,34,11

do	
	Taste = FF_ShowDialog (dlg)
	Select Case Taste
	Case "Lschen"
		z = 0
		for m = 1 to AnzahlV
			for n = 1 to AnzahlH
				z = z + 1 : Name = cstr(z)		
				FF_SetControl dlg,Name,0
				KW(z) = 0
			next
		next
		K_Auswahl = ""
		FF_EnableControl "Kachelschatten","AnzahlH",true
		FF_EnableControl "Kachelschatten","AnzV",true
	Case "bernehmen"
		K_Auswahl = "/" : z = 0
		for m = 1 to AnzahlV
			for n = 1 to AnzahlH
				z = z + 1 : Name = cstr(z)
				if FF_GetControl (dlg,Name) * 1 > 0 then
					K_Auswahl = K_Auswahl & Name & "/"
					KW(z) = FF_GetControl (dlg,Name)
				end if
			next
		next
		
		if len(K_Auswahl) > 2 then
			FF_EnableControl "Kachelschatten","AnzahlH",false
			FF_EnableControl "Kachelschatten","AnzV",false
			exit do
		else
			K_Auswahl = ""
			msgbox "Es wurde keine Auswahl getroffen!",vbInformation,"Ergebnis"
		end if
	Case "Abbrechen","CANCEL"
		exit do
	Case Else
		if left(Taste,1) = "n" then
			z = mid(Taste,2)
			c = FF_GetControl (dlg,z) * 1 + FF_GetControl (dlg,Taste) * 1
			if c < 0 then c = 8
			if c > 8 then c = 0
			FF_SetControl dlg,z,c
		end if
	End Select
loop

FF_CloseDialog (dlg)

End Sub
'----------------------------------------------------------------------
Sub TransparenzErzeugung

Dim a,b,z,Name	'Zhlfaktoren
Dim modX,modY	'gerade oder ungerade
Dim y,x			'Horizontal- und Vertikalkoordinaten
Dim K,KL,Trans	'Korrektur, Transparenz

if flagOVers = 1 then
	K = 0
	if boolSchatten = 1 then KL = LinSt else KL = 0
else
	K = LinSt
	KL = 0
end if

Randomize

for a = 0 to AnzahlV			'Vertikal
	modX = a mod 2
	y = (Kachelhoehe + K) * a
	
	for b = 0 to AnzahlH - 1	'Horizontal
		modY = b mod 2
		x = (Kachelbreite + K) * b
		
		if flagAbwechslung = 1 then
			if flagTStart = 0 then
				if (modX xor modY) = 0 then
					FF_AreaFillRect x,y,x+Kachelbreite-KL,y+Kachelhoehe-KL,MaxTransWert
				else
					FF_AreaFillRect x,y,x+Kachelbreite-KL,y+Kachelhoehe-KL,0
				end if
			else
				if (modX xor modY) = 1 then
					FF_AreaFillRect x,y,x+Kachelbreite-KL,y+Kachelhoehe-KL,MaxTransWert
				else
					FF_AreaFillRect x,y,x+Kachelbreite-KL,y+Kachelhoehe-KL,0
				end if
			end if		
		elseif flagZufall = 1 then
			if Rnd < .5 then
				FF_AreaFillRect x,y,x+Kachelbreite-KL,y+Kachelhoehe-KL,MaxTransWert
			else
				FF_AreaFillRect x,y,x+Kachelbreite-KL,y+Kachelhoehe-KL,0
			end if
		elseif flagZufallswerte = 1 then
			FF_AreaFillRect x,y,x+Kachelbreite-KL,y+Kachelhoehe-KL,int(Rnd * MaxTransWert)
		elseif flagGezielt = 1 then
			z = z + 1 : Name = "/" & cstr(z) & "/"
			if instr(K_Auswahl,Name) > 0 then
				if DW_mE then
					FF_AreaFillRect x,y,x+Kachelbreite-KL,y+Kachelhoehe-KL,KW(z) * 32 - 1
				else
					FF_AreaFillRect x,y,x+Kachelbreite-KL,y+Kachelhoehe-KL,MaxTransWert
				end if
			else
				FF_AreaFillRect x,y,x+Kachelbreite-KL,y+Kachelhoehe-KL,0
			end if
		end if
		
		KZ = KZ + 1										'Fortschrittsanzeige
		FF_SetControl "Kachelschatten","Fortschritt",KZ/GesamtKZ*100
		
	next
next		

FF_LinContrast(2.)

End Sub
'----------------------------------------------------------------------
Sub Umrandung_oV
'Umrandung ohne Versatz

if LinSt = 0 then exit sub

Dim a,b			'Zhlfaktoren
Dim xstart,ystart,xend,yend

xstart = 0 : xend = Breite
for a = 1 to AnzahlV - 1		'Vertikal
	ystart = Kachelhoehe * a
	yend = ystart
	FF_Line xstart,ystart,xend,yend,RGB,LinSt
	
	KZ = KZ + 1									'Fortschrittsanzeige
	FF_SetControl "Kachelschatten","Fortschritt",KZ/GesamtKZ*100
next

ystart = 0 : yend = Hoehe	
for b = 1 to AnzahlH - 1		'Horizontal
	xstart = Kachelbreite * b
	xend = xstart
	FF_Line xstart,ystart,xend,yend,RGB,LinSt
	
	KZ = KZ + 1									'Fortschrittsanzeige
	FF_SetControl "Kachelschatten","Fortschritt",KZ/GesamtKZ*100
next

'Bildgre rekonstruieren
FF_HQScale OrgBreite,OrgHoehe,false

End Sub
'------------------------------------------------------------------------
Sub Umrandung_mV
'Umrandung mit Versatz

Dim y,yo,x,xo,xs,ys

FF_NewImage KachelSh_H-LinSt,KachelSh_V-LinSt,RGB
FF_PushImage

for y = 0 to Hoehe - .5 step Kachelhoehe						'Vertikale
	if y = 0 then yo = 0 else yo = yo + LinSt

	for x = 0 to Breite - .5 step Kachelbreite					'Horizontale
		if x = 0 then xo = 0 else xo = xo + LinSt
		
		KZ = KZ + 1												'Fortschrittsanzeige
		FF_SetControl "Kachelschatten","Fortschritt",KZ/GesamtKZ*100
		
		FF_LoadImage TempFile

		FF_Crop x,y,Kachelbreite,Kachelhoehe					'Ausschneiden
			
		xs = x + xo
		ys = y + yo
		FF_MixImage xs,ys,Kachelbreite,Kachelhoehe,255			'Mischen
	next
next

FF_PopImage

'Bildgre rekonstruieren
FF_HQScale OrgBreite+AnzahlH*LinSt-LinSt,OrgHoehe+AnzahlV*LinSt-LinSt,false

End sub
'---------------------------------------------------------------------
Sub RegistryLesen
'Schlsselname = HKEY_CURRENT_USER\Software\Joachim Koopmann Software\FixFoto\Script\FF_Kachelschatten
Dim n

'### Werte auslesen
AnzahlH = FF_GetProfile("FF_Kachelschatten","AnzahlH")
if AnzahlH = "" then AnzahlH = 10
AnzV = FF_GetProfile("FF_Kachelschatten","AnzV")
if AnzV = "" then AnzV = 5
LinSt = FF_GetProfile("FF_Kachelschatten","LinSt")
if LinSt = "" then LinSt = 10
RandSt = FF_GetProfile("FF_Kachelschatten","RandSt")
if RandSt = "" then RandSt = LinSt
LinCol = FF_GetProfile("FF_Kachelschatten","LinCol")
if LinCol = "" then LinCol = "255 255 255"
boolSchatten = FF_GetProfile("FF_Kachelschatten","boolSchatten")
if boolSchatten = "" then boolSchatten = 1
flagOVers = FF_GetProfile("FF_Kachelschatten","flagOVers")
if flagOVers = "" then flagOVers = 0
mitRand = FF_GetProfile("FF_Kachelschatten","mitRand")
if mitRand = "" then mitRand = 0
boolTransparenz = FF_GetProfile("FF_Kachelschatten","boolTransparenz")
if boolTransparenz = "" then boolTransparenz = 0
flagAbwechslung = FF_GetProfile("FF_Kachelschatten","flagAbwechslung")
if flagAbwechslung = "" then flagAbwechslung = 1
flagTStart = FF_GetProfile("FF_Kachelschatten","flagTStart")
if flagTStart = "" then flagTStart = 0
flagZufall = FF_GetProfile("FF_Kachelschatten","flagZufall")
if flagZufall = "" then flagZufall = 0
flagZufallswerte = FF_GetProfile("FF_Kachelschatten","flagZufallswerte")
if flagZufallswerte = "" then flagZufallswerte = 0
flagGezielt = FF_GetProfile("FF_Kachelschatten","flagGezielt")
if flagGezielt = "" then flagGezielt = 0
K_Auswahl = FF_GetProfile("FF_Kachelschatten","K_Auswahl")
MaxTransWert = FF_GetProfile("FF_Kachelschatten","MaxTransWert")
if MaxTransWert = "" then MaxTransWert = 255
TransWerte = FF_GetProfile("FF_Kachelschatten","TransWerte")
if TransWerte = "" then
	for n = 0 to 200
		TransWerte = TransWerte & "/0"
	next
end if

'### Werte eintragen
FF_SetControl "Kachelschatten","AnzahlH",AnzahlH
FF_SetControl "Kachelschatten","AnzV",AnzV
FF_SetControl "Kachelschatten","LinSt",LinSt
FF_SetControl "Kachelschatten","RandSt",RandSt
FF_SetControl "Kachelschatten","LinCol",LinCol
FF_SetControl "Kachelschatten","boolSchatten",boolSchatten
if boolSchatten = 0 then
	FF_SetControl "Kachelschatten","boolOhneSchatten",1
end if
FF_SetControl "Kachelschatten","flagOVers",flagOVers
if flagOVers = 0 then
	FF_SetControl "Kachelschatten","flagMVers",1
end if
FF_SetControl "Kachelschatten","mitRand",mitRand
FF_SetControl "Kachelschatten","boolTransparenz",boolTransparenz
FF_SetControl "Kachelschatten","flagAbwechslung",flagAbwechslung
FF_SetControl "Kachelschatten","flagTStart",flagTStart
FF_SetControl "Kachelschatten","flagZufall",flagZufall
FF_SetControl "Kachelschatten","flagZufallswerte",flagZufallswerte
FF_SetControl "Kachelschatten","flagGezielt",flagGezielt

if boolTransparenz = 1 and flagGezielt = 1 and K_Auswahl <> "" then
	FF_EnableControl "Kachelschatten","AnzahlH",false
	FF_EnableControl "Kachelschatten","AnzV",false
end if

FF_SetControl "Kachelschatten","MaxTransEinstellung",MaxTransWert
KWr = split(TransWerte,"/")
for n = 0 to ubound(KWr) - 1
	KW(n) = KWr(n)
next

End Sub
'------------------------------------------------------------------------
Sub RegistrySchreiben
'Schlsselname = HKEY_CURRENT_USER\Software\Joachim Koopmann Software\FixFoto\Script\FF_Kachelschatten

'### Werte auslesen
AnzahlH = FF_GetControl("Kachelschatten","AnzahlH")
AnzV = FF_GetControl("Kachelschatten","AnzV")
LinSt = FF_GetControl("Kachelschatten","LinSt")
RandSt = FF_GetControl("Kachelschatten","RandSt")
LinCol = FF_GetControl("Kachelschatten","LinCol")
boolSchatten = FF_GetControl("Kachelschatten","boolSchatten")
flagOVers = FF_GetControl("Kachelschatten","flagOVers")
mitRand = FF_GetControl("Kachelschatten","mitRand")
boolTransparenz = FF_GetControl("Kachelschatten","boolTransparenz")
flagAbwechslung = FF_GetControl("Kachelschatten","flagAbwechslung")
flagTStart = FF_GetControl("Kachelschatten","flagTStart")
flagZufall = FF_GetControl("Kachelschatten","flagZufall")
flagZufallswerte = FF_GetControl("Kachelschatten","flagZufallswerte")
flagGezielt = FF_GetControl("Kachelschatten","flagGezielt")
MaxTransWert = FF_GetControl("Kachelschatten","MaxTransEinstellung")
TransWerte = join(KW,"/")

'### Werte eintragen
FF_WriteProfile "FF_Kachelschatten","AnzahlH",AnzahlH
FF_WriteProfile "FF_Kachelschatten","AnzV",AnzV
FF_WriteProfile "FF_Kachelschatten","LinSt",LinSt
FF_WriteProfile "FF_Kachelschatten","RandSt",RandSt
FF_WriteProfile "FF_Kachelschatten","LinCol",LinCol
FF_WriteProfile "FF_Kachelschatten","boolSchatten",boolSchatten
FF_WriteProfile "FF_Kachelschatten","flagOVers",flagOVers
FF_WriteProfile "FF_Kachelschatten","mitRand",mitRand
FF_WriteProfile "FF_Kachelschatten","boolTransparenz",boolTransparenz
FF_WriteProfile "FF_Kachelschatten","flagAbwechslung",flagAbwechslung
FF_WriteProfile "FF_Kachelschatten","flagTStart",flagTStart
FF_WriteProfile "FF_Kachelschatten","flagZufall",flagZufall
FF_WriteProfile "FF_Kachelschatten","flagZufallswerte",flagZufallswerte
FF_WriteProfile "FF_Kachelschatten","flagGezielt",flagGezielt
FF_WriteProfile "FF_Kachelschatten","K_Auswahl",K_Auswahl
FF_WriteProfile "FF_Kachelschatten","MaxTransWert",MaxTransWert
FF_WriteProfile "FF_Kachelschatten","TransWerte",TransWerte

End Sub
'------------------------------------------------------------------------
Sub KurzbeschreibungAnzeigen

Dim Taste
Dim BreiteKB	: BreiteKB = LaengeMax * 2.6 + 15
const Hoehe = 180

const ES_READONLY = 2048
const WS_VSCROLL = 2097152

FF_AddDialog "Kurzbeschreibung",BreiteKB,Hoehe
FF_AddControl "Kurzbeschreibung","Beschreibung","EDIT",0,0,BreiteKB,Hoehe-20
FF_SetControlStyle "Kurzbeschreibung","Beschreibung", ES_READONLY + WS_VSCROLL
FF_AddControl "Kurzbeschreibung","OK","BUTTON",BreiteKB/2-15,Hoehe-15,30,10

FF_SetControl "Kurzbeschreibung","Beschreibung",Kurzbeschreibung

do
	Taste = FF_ShowDialog("Kurzbeschreibung")
	if Taste = "CANCEL" or Taste = "OK" then exit do
loop
call FF_CloseDialog("Kurzbeschreibung")

End Sub
'------------------------------------------------------------------------
Sub KurzbeschreibungLesen
on error resume next
Const ForReading = 1
Dim Skript, Anfang, Ende, Zeile, ZZ

Set Skript = objFS.OpenTextFile(FF_GetScriptPath & "\" & SkriptName, ForReading, False)

if err.number = 53 then
	msgbox "Wahrscheinlich wurde der Originalskriptname " & """" & SkriptName & """" & " abgendert." & vbNewLine & _
		   "Die Kurzbeschreibung kann daher nicht angezeigt werden.",vbExclamation,"Meldung"
	Abbruch = True
	exit sub
end if

Do While Skript.AtEndOfStream <> True
	Zeile = Skript.ReadLine
	
	ZZ = ZZ + 1
	if ZZ > 1000 then msgbox "Fehler in der Kurzbeschreibung! (objFS?)" : exit sub
	
	if instr(Zeile,"** Ende Kurzbeschreibung") > 0 then Ende = true
	if Ende then exit do
	
	if Anfang then Kurzbeschreibung = Kurzbeschreibung & mid(Zeile,2) & vbNewLine
	if len(Zeile)-1 > LaengeMax then LaengeMax = len(Zeile)-1
	
	if instr(Zeile,"** Start Kurzbeschreibung") > 0 then Anfang = true
	
Loop
	
if Anfang and Ende then KBvorhanden = true
Skript.Close

End Sub
'------------------------------------------------------------------------
Sub KillSkript
'Skript komplett entfernen
Dim SPfad
const RegSchluessel = "\FF_Kachelschatten\"

'### FixFotoScript.ini bereinigen
TempFile = FF_GetFFPathEx(1) & "\FixFotoScript.ini"
if objFS.FileExists(TempFile) then
	call IniBereinigung
else
	msgbox "Die Datei FixFotoScript.ini konnte nicht gefunden werden!" & vbNewLine & _
		   "Der Lschvorgang wird abgebrochen!",vbExclamation,"Hinweis"
	exit sub
end if

'### zip-Archiv auf Wunsch sichern, dann lschen
TempFile = FF_GetScriptPath & "\" & objFS.GetBaseName(Skriptname) & ".zip"
if objFS.FileExists(TempFile) then
	Antwort = msgbox("Soll das Archiv " & objFS.GetBaseName(Skriptname) & ".zip" & _
					" gesichert werden?",vbYesNo + vbQuestion,"Sicherheitskopie")
	if Antwort = vbYes then
		SPfad = FF_EnterPath(true,"Wo soll die Sicherheitskopie angelegt werden?")
		if SPfad = "" then
			msgbox "Das Lschen des Skript wird abgebrochen!",vbExclamation,"Hinweis"
			exit sub
		end if
		SPfad = SPfad & "\" & objFS.GetBaseName(Skriptname) & ".zip"
		objFS.CopyFile Tempfile, SPfad, True
	end if
	objFS.DeleteFile TempFile,true
end if

'### Skriptdatei lschen
TempFile = FF_GetScriptPath & "\" & Skriptname
objFS.DeleteFile TempFile,true

'### Registry-Daten lschen
TempFile = "HKEY_CURRENT_USER\Software\Joachim Koopmann Software\FixFoto\Script" & RegSchluessel
WshShell.RegDelete(TempFile)

'### Fertigmeldung
msgbox "Nach Durchfhrung der 'Automatischen Skriptkonfiguration' ist das Skript" & vbNewLine & _
	   Skriptname & " mit allen Komponenten gelscht!",vbExclamation,"Hinweis"
	   
End Sub
'------------------------------------------------------------------------
Sub IniBereinigung
'FixFotoScript.ini - Bereinigung

Dim Zeile,zNr,Anfang,Ende
Dim DateiTmp,ZielZeile,tmpString
DateiTmp =  FF_GetFFPathEx(1) & "\FixFotoScript.tmp"

'Wo befindet sich der Eintrag zum Skript
Set Zeile = objFS.OpenTextFile(TempFile, ForReading)

zNr = 0
do Until Zeile.AtEndOfStream
	tmpString = Zeile.ReadLine
	zNr = zNr + 1
	if tmpString = "[Script]" then Anfang = zNr
	if tmpString = "File=.\" & Skriptname then
		Ende = zNr
		exit do	
	end if
loop 
Zeile.Close

if Ende <= Anfang then
	msgbox "Die Datei FixFotoScript.ini konnte nicht bereinigt werden!",vbExclamation,"Hinweis"
	exit sub
end if

'Zeilen ohne skriptbezogene Zeilen in DateiTmp bertragen
Set Zeile = objFS.OpenTextFile(TempFile, ForReading)
Set ZielZeile  = objFS.CreateTextFile(DateiTmp, True)

zNr = 0
do Until Zeile.AtEndOfStream
	tmpString = Zeile.ReadLine
	zNr = zNr + 1
	if zNr < Anfang or zNr > Ende then
		ZielZeile.WriteLine tmpString
	end if
loop 

Zeile.Close
ZielZeile.Close

'Umkopieren von DateiTmp nach FixFotoScript.ini (TempFile)
objFS.CopyFile DateiTmp, TempFile, True
objFS.DeleteFile (DateiTmp)

End Sub
'------------------------------------------------------------------------
'************************************************************************
'Update-Funktion
'************************************************************************
Sub Update

call Versionsermittlung_url

if not Abbruch then
	SkriptV_Zahl = Replace(SkriptVersion,".","") *1
	
	if UrlV_Zahl = SkriptV_Zahl then
		msgbox "Die Version " & SkriptVersion & " ist aktuell!",vbInformation,"Versionsmeldung"
	elseif SkriptV_Zahl < UrlV_Zahl then
		Antwort = msgbox("Die Skriptversion " & SkriptVersion & " ist nicht mehr aktuell!" & vbNewLine &_
				"Es steht die Version " & UrlVersion & " zum Download bereit." & vbNewLine & vbNewLine & _
				"Soll die Downloadseite aufgerufen werden?",vbQuestion + vbYesNo,"Versionsmeldung")
		if Antwort = vbYes then
			on error resume next
			WshShell.Run SkriptUrl,1,false
			if err <> 0 then
				msgbox "Die Downloadseite wurde nicht gefunden!",vbExclamation,"Hinweis"
			else
				SkriptEnde = true
			end if
			on error goto 0
		end if
	else
		msgbox 	"Es liegt ein Fehler in den Versionsangaben vor." & vbNewLine &_
				"Die Skriptversion " & SkriptVersion & " ist grer als die auf" & vbNewLine &_
				"der Downloadseite angegebene Version " & UrlVersion & ".",vbInformation,"Fehlermeldung"
	end if
end if

End Sub
'------------------------------------------------------------------------
Sub Versionsermittlung_url

Dim Inhalt,Start,Zeit,pos1,pos2,n
Dim xml, Fehler
Fehler = false

on error resume next
Set xml = CreateObject("Microsoft.XMLHTTP")
xml.Open "Get",SkriptUrl,false
xml.Send

Inhalt = xml.responseText

if err > 0 then
	Fehler = true
else
	'Version suchen und anzeigen
	pos1 = instr(Inhalt,"Version")
	if pos1 > 0 then
	
		pos2 = instr(pos1 ,Inhalt,"<br")
		if pos2 > 0 then
			UrlVersion = trim(mid(Inhalt,pos1,pos2-pos1))
		else
			Fehler = true
		end if
	else
		Fehler = true
	end if
end if

Set xml = nothing

if Fehler then
	msgbox  "Die Versionsangabe wurde nicht gefunden!" & vbNewLine &_
			"Mglicherweise funktioniert der Internetaufruf nicht." & vbNewLine & vbNewLine & _
			"Am besten nochmal probieren!",vbExclamation,"Fehlermeldung"
	Abbruch = true
	exit sub
end if

'Version als Zahl
pos1 = instr(UrlVersion," ")
if pos1 = 0 then pos1 = 7
UrlVersion = trim(mid(UrlVersion,pos1+1))
UrlV_Zahl = Replace(UrlVersion,".","") *1

End Sub
'------------------------------------------------------------------------